// copy van usmodel_hist_dsge_f19_7_71

var ewma epinfma zcapf rkf kf pkf cf invef yf labf wf rrf mc zcap rk k pk c inve y lab pinf w r a b g qs ms spinf sw kpf kp robs pinfobs labobs dw dinve dc dy;
 
varexo ea eb eg  eqs  em  epinf ew  ;  
 
parameters 
csadjcost csigma chabb cprobw csigl cprobp cindw cindp czcap cfc crpi crr cry crdy constepinf constebeta
constelab ctrend calfa s_tech s_riskp s_gov s_inv s_rant s_epinf s_ew 
crhoa crhob crhog crhoqs crhoms crhopinf crhow
cmap cmaw cgy
ctou clandaw cg curvp curvw crhols crhoas cbetabar cgamma crk cwhlc ccy ciy crkky cikbar conster;

% fixed parameters
constebeta=0.16;
ctou=.025;
clandaw=1.5;
cg=0.18;
curvp=10;
curvw=10;
crhols=   0.9928;
crhoas=1; 

% estimated parameters initialisation
uno=parametrar_funktion(3);
csadjcost= uno(1);
csigma=uno(2);
chabb=uno(3);    
cprobw=uno(4);
csigl=uno(5);
cprobp=uno(6);
cindw=uno(7);
cindp=uno(8);
czcap=uno(9);
cfc=uno(10);
crpi=uno(11);
crr=uno(12);
cry=uno(13);
crdy=uno(14);
constepinf=uno(15);
constelab=uno(16);
ctrend=uno(17);
calfa=uno(18);

s_tech=uno(19);
s_riskp=uno(20); 
s_gov=uno(21);  
s_inv=uno(22);  
s_rant=uno(23);  
s_epinf=uno(24);  
s_ew=uno(25);
crhoa=uno(26);
crhob=uno(27);
crhog=uno(28);
crhoqs=uno(29);
crhoms=uno(30);
crhopinf=uno(31);
crhow=uno(32);
cmap=uno(33);
cmaw=uno(34);
cgy=uno(35);


cpie=1+constepinf/100;
cgamma=1+ctrend/100 ;
cbeta=1/(1+constebeta/100);

clandap=cfc;
cbetabar=cbeta*cgamma^(-csigma);
cr=cpie/(cbeta*cgamma^(-csigma));
crk=(cbeta^(-1))*(cgamma^csigma) - (1-ctou);
cw = (calfa^calfa*(1-calfa)^(1-calfa)/(clandap*crk^calfa))^(1/(1-calfa));
%cw = (calfa^calfa*(1-calfa)^(1-calfa)/(clandap*((cbeta^(-1))*(cgamma^csigma) - (1-ctou))^calfa))^(1/(1-calfa));
cikbar=(1-(1-ctou)/cgamma);
cik=(1-(1-ctou)/cgamma)*cgamma;
clk=((1-calfa)/calfa)*(crk/cw);
cky=cfc*(clk)^(calfa-1);
ciy=cik*cky;
ccy=1-cg-cik*cky;
crkky=crk*cky;
cwhlc=(1/clandaw)*(1-calfa)/calfa*crk*cky/ccy;
cwly=1-crk*cky;
conster=(cr-1)*100;

model(linear); 

%@#include "usmodel_stst.mod"

// flexible economy

	      0*(1-calfa)*a + 1*a =  calfa*rkf+(1-calfa)*(wf)  ;
	      zcapf =  (1/(czcap/(1-czcap)))* rkf  ;
	      rkf =  (wf)+labf-kf ;
	      kf =  kpf(-1)+zcapf ;
	      invef = (1/(1+cbetabar*cgamma))* (  invef(-1) + cbetabar*cgamma*invef(1)+(1/(cgamma^2*csadjcost))*pkf ) +qs ;
          pkf = -rrf-0*b+(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b +(crk/(crk+(1-ctou)))*rkf(1) +  ((1-ctou)/(crk+(1-ctou)))*pkf(1) ;
	      cf = (chabb/cgamma)/(1+chabb/cgamma)*cf(-1) + (1/(1+chabb/cgamma))*cf(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(labf-labf(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(rrf+0*b) + b ;
	      yf = ccy*cf+ciy*invef+g  +  crkky*zcapf ;
	      yf = cfc*( calfa*kf+(1-calfa)*labf +a );
	      wf = csigl*labf 	+(1/(1-chabb/cgamma))*cf - (chabb/cgamma)/(1-chabb/cgamma)*cf(-1) ;
	      kpf =  (1-cikbar)*kpf(-1)+(cikbar)*invef + (cikbar)*(cgamma^2*csadjcost)*qs ;

// sticky price - wage economy

	      mc =  calfa*rk+(1-calfa)*(w) - 1*a - 0*(1-calfa)*a ;
	      zcap =  (1/(czcap/(1-czcap)))* rk ;
	      rk =  w+lab-k ;
	      k =  kp(-1)+zcap ;
	      inve = (1/(1+cbetabar*cgamma))* (  inve(-1) + cbetabar*cgamma*inve(1)+(1/(cgamma^2*csadjcost))*pk ) +qs ;
          pk = -r+pinf(1)-0*b +(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b + (crk/(crk+(1-ctou)))*rk(1) +  ((1-ctou)/(crk+(1-ctou)))*pk(1) ;
	      c = (chabb/cgamma)/(1+chabb/cgamma)*c(-1) + (1/(1+chabb/cgamma))*c(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(lab-lab(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(r-pinf(+1) + 0*b) +b ;
	      y = ccy*c+ciy*inve+g  +  1*crkky*zcap ;
	      y = cfc*( calfa*k+(1-calfa)*lab +a );
	      pinf =  (1/(1+cbetabar*cgamma*cindp)) * ( cbetabar*cgamma*pinf(1) +cindp*pinf(-1) 
               +((1-cprobp)*(1-cbetabar*cgamma*cprobp)/cprobp)/((cfc-1)*curvp+1)*(mc)  )  + spinf ; 
	      w =  (1/(1+cbetabar*cgamma))*w(-1)
               +(cbetabar*cgamma/(1+cbetabar*cgamma))*w(1)
               +(cindw/(1+cbetabar*cgamma))*pinf(-1)
               -(1+cbetabar*cgamma*cindw)/(1+cbetabar*cgamma)*pinf
               +(cbetabar*cgamma)/(1+cbetabar*cgamma)*pinf(1)
               +(1-cprobw)*(1-cbetabar*cgamma*cprobw)/((1+cbetabar*cgamma)*cprobw)*(1/((clandaw-1)*curvw+1))*
               (csigl*lab + (1/(1-chabb/cgamma))*c - ((chabb/cgamma)/(1-chabb/cgamma))*c(-1) -w) 
               + 1*sw ;
	      r =  crpi*(1-crr)*pinf
               +cry*(1-crr)*(y-yf)     
               +crdy*(y-yf-y(-1)+yf(-1))
               +crr*r(-1)
               +ms  ;
	      a = crhoa*a(-1)  + ea;
	      b = crhob*b(-1) + eb;
	      g = crhog*(g(-1)) + eg + cgy*ea;
	      qs = crhoqs*qs(-1) + eqs;
	      ms = crhoms*ms(-1) + em;
	      spinf = crhopinf*spinf(-1) + epinfma - cmap*epinfma(-1);
	          epinfma=epinf;
	      sw = crhow*sw(-1) + ewma - cmaw*ewma(-1) ;
	          ewma=ew; 
	      kp =  (1-cikbar)*kp(-1)+cikbar*inve + cikbar*cgamma^2*csadjcost*qs ;

// measurment equations

dy=y-y(-1)+ctrend;
dc=c-c(-1)+ctrend;
dinve=inve-inve(-1)+ctrend;
dw=w-w(-1)+ctrend;
pinfobs = 1*(pinf) + constepinf;
robs =    1*(r) + conster;
labobs = lab + constelab;

end; 

%resid(0);
%steady;

%check;


shocks;
var ea;
stderr s_tech;
var eb;
stderr s_riskp;
var eg;
stderr s_gov;
var eqs;
stderr s_inv;
var em;
stderr s_rant;
var epinf;
stderr s_epinf;
var ew;
stderr s_ew;
end;


tres=min_max_funk(3);
estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_P1, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF
csadjcost,6.3325,tres(1,1),tres(1,2);
csigma,1.2312,tres(2,1),tres(2,2);
chabb,0.7205,tres(3,1),tres(3,2);
cprobw,0.7937,tres(4,1),tres(4,2);
csigl,2.8401,tres(5,1),tres(5,2);
cprobp,0.7813,tres(6,1),tres(6,2);
cindw,0.4425,tres(7,1),tres(7,2);
cindp,0.3291,tres(8,1),tres(8,2);
czcap,0.2648,tres(9,1),tres(9,2);
cfc,1.4672,tres(10,1),tres(10,2);
crpi,1.7985,tres(11,1),tres(11,2);
crr,0.8258,tres(12,1),tres(12,2);
cry,0.0893,tres(13,1),tres(13,2);
crdy,0.2239,tres(14,1),tres(14,2);
constepinf,0.7,tres(15,1),tres(15,2);
constelab,1.2918,tres(16,1),tres(16,2);
ctrend,0.3982,tres(17,1),tres(17,2);
calfa,0.24,tres(18,1),tres(18,2);
stderr ea,0.1,tres(19,1),tres(19,2);
stderr eb,0.1,tres(20,1),tres(20,2);
stderr eg,0.1,tres(21,1),tres(21,2);
stderr eqs,0.1,tres(22,1),tres(22,2);
stderr em,0.1,tres(23,1),tres(23,2);
stderr epinf,0.1,tres(24,1),tres(24,2);
stderr ew,0.1,tres(25,1),tres(25,2);
crhoa,.9676,tres(26,1),tres(26,2);
crhob,.2703,tres(27,1),tres(27,2);
crhog,.9930,tres(28,1),tres(28,2);
crhoqs,.5724,tres(29,1),tres(29,2);
crhoms,.3,tres(30,1),tres(30,2);
crhopinf,.8692,tres(31,1),tres(31,2);
crhow,.9546,tres(32,1),tres(32,2);
cmap,.7652,tres(33,1),tres(33,2);
cmaw,.8936,tres(34,1),tres(34,2);
cgy,0.05,tres(35,1),tres(35,2);
end;

varobs dy dc dinve labobs pinfobs dw robs;

%stoch_simul(order=1, periods=11000, irf=40) dy; 
%stoch_simul(order=1, periods=11000, irf=40, nograph, noprint); 
%estimation(optim=('MaxIter',200),datafile=usmodel_data_eget,mode_file=modfile_common_mh_mode,mode_compute=0,first_obs=1, presample=4,lik_init=2,prefilter=0,mh_replic=10,mh_nblocks=2,mh_jscale=0.20,mh_drop=0.2, nograph, nodiagnostic, tex);

%rand('state',3)
set_dynare_seed('clock');
%estimation(order=1, datafile=usmodel_data_eget, mh_replic=10, mh_nblocks=2, mh_jscale=0.8, use_univariate_filters_if_singularity_is_detected=0, nograph, nodiagnostic);
estimation(order=1, datafile=usmodel_data, mh_replic=10, mh_nblocks=2, mh_jscale=0.8, use_univariate_filters_if_singularity_is_detected=0, nograph, nodiagnostic);


%estimation(datafile=usmodel_data,first_obs=1, presample=4,lik_init=2,prefilter=0,mh_replic=10,mh_nblocks=2,mh_jscale=0.20,mh_drop=0.2, nograph, nodiagnostic, tex);
global dataset_  bayestopt_ 
[dataset_,xparam1, hh, M_, options_, oo_, estim_params_,bayestopt_] = dynare_estimation_init(var_list_, M_.fname, [], M_, options_, oo_, estim_params_, bayestopt_);
%eval(m_fil);
%estimation(order=1, datafile=usmodel_data, nobs=192, loglinear, mh_replic=10, mh_nblocks=2, mh_jscale=0.8);
%estimation(order=1, datafile=usmodel_data, loglinear, mh_replic=10, mh_nblocks=2, mh_jscale=0.8, lik_init=2);

%shock_decomposition y;
//shock_decomposition(labels=(ea)) y;